AnimalsManagerVisualHud = {};

function AnimalsManagerVisualHud:loadHud()
	AnimalsManagerVisualHud.size = 0.009;
	AnimalsManagerVisualHud.heightDistance = 0.004;
	AnimalsManagerVisualHud.widthDistance = 0.005;
	AnimalsManagerVisualHud.widthSeparatorDistance = 0.03;	
	AnimalsManagerVisualHud.globalTimer = 0;
	AnimalsManagerVisualHud.color = {
		prozent = {	{255/255, 	255/255, 	255/255,	1.00 }, --white
					{  0/255,	255/255, 	  0/255, 	1.00 }, --green
					{154/255, 	205/255,  	 50/255,	1.00 }, --yellowGreen
					{255/255, 	255/255, 	  0/255, 	1.00 }, --yellow
					{255/255, 	 65/255, 	  0/255, 	1.00 }, --orange
					{255/255,   28/255,   	  0/255, 	1.00 }, --orangeRed
					{255/255,	  0/255, 	  0/255, 	1.00 }  --red
		}	
	};
	AnimalsManager.overlays = {};
	local _,isOkay = AnimalsManager:get_hl("getSetDefaultBackground", {AnimalsManager.overlays, "groundAnimalVisual"}, "getSetDefaultBackground groundAnimalVisual");
	local _,isOkay1 = AnimalsManager:get_hl("setBackgroundColor", {AnimalsManager.overlays["groundAnimalVisual"], {0,0,0,0.7}}, "setBackgroundColor groundAnimalVisual");
	local _,isOkay2 = AnimalsManager:get_hl("getSetDefaultBackground", {AnimalsManager.overlays, "lineAnimalVisual"}, "getSetDefaultBackgroundLine lineAnimalVisual");
	local _,isOkay3 = AnimalsManager:get_hl("setBackgroundColor", {AnimalsManager.overlays["lineAnimalVisual"], {0,0,0,0.7}}, "setBackgroundLineColor lineAnimalVisual");
	AnimalsManagerVisualHud.loadOverlays = isOkay and isOkay1 and isOkay2 and isOkay3;
	--AnimalsManagerVisualHud.isDrawVehicleName = false;
end;

function AnimalsManagerVisualHud:update()
	local px,py,pz = getWorldTranslation(g_currentMission.player.rootNode);	
	if px ~= nil and py ~= nil and pz ~= nil then --onFood Player
		local maxDistance = 25;
		local nearDistance = 0;
		local isVisible = false;
		for key, animalObject in pairs(AnimalsManager.indexToAnimals) do			
			if animalObject ~= nil then
				local ox,oy,oz = getWorldTranslation(animalObject.nodeId);
				local distance = MathUtil.vector3Length(px-ox, py-oy, pz-oz);
				local distance1 = MathUtil.vector3Length(ox, oy, oz);
				if distance <= maxDistance and nearDistance <= distance and not isVisible then
					nearDistance = distance;
					isVisible = true;					
					AnimalsManagerVisualHud:createHud(animalObject);
					if animalObject.visualHud ~= nil then animalObject.visualHud.isVisible = true;end;
					AnimalsManagerVisualHud:draw(animalObject, distance, distance1);
				else
					if animalObject.visualHud ~= nil then animalObject.visualHud.isVisible = false;end;
					if animalObject.visualHudFillTypesTicker ~= nil then
						for key, value in pairs(animalObject.visualHudFillTypesTicker) do
							value.isTimer = 0;value.isFillType=1;
						end;
					end;
				end;
			end;
		end;
	end;
end;

function AnimalsManagerVisualHud:draw(self, distance, distance1)
	if self ~= nil and self.visualHud ~= nil and self.visualHud.isVisible then
		AnimalsManagerVisualHud.globlaTimer = AnimalsManagerVisualHud.globalTimer+1;
		--respect settings for other mods
		setTextAlignment(0);
		setTextColor(1, 1, 1, 1);
		setTextBold(false);
		--respect settings for other mods
		--renderText(0.6, 0.1, 0.010, "Near AnimalsManagerVisualHud..".. tostring(distance).. " - ".. tostring(distance1))
		local isOutput = false;
		local widthDistance = AnimalsManagerVisualHud.widthDistance;
		local heightDistance = AnimalsManagerVisualHud.heightDistance;
		local posX = 0.5-(self.visualHud.maxWidth/2);
		local posY = 0.02+self.visualHud.maxHeight;
		local size = AnimalsManagerVisualHud.size;
		if AnimalsManagerVisualHud.loadOverlays then
			AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["groundAnimalVisual"], posX,0.02-heightDistance,self.visualHud.maxWidth, self.visualHud.maxHeight+heightDistance}, "setOverlay Background AnimalsVisualHud");
			AnimalsManager.overlays["groundAnimalVisual"]:render();		
		end;
		setTextBold(true);
		renderText(posX, posY+(heightDistance/2), size+0.0005, tostring(g_i18n:getText("category_animals")).. "-Info")
		for key, output in pairs(self.visualHud.output) do			
			setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[1]));
			local txtHeight = getTextHeight(size, tostring(output[1]))+heightDistance;			
			if output[3] > 0 then setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[output[3]]));end;
			renderText(posX+widthDistance, posY-txtHeight, size, tostring(output[1]));			
			setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[1]));
			local txtWidth = getTextWidth(size, tostring(output[2]))+widthDistance;			
			if output[4] > 0 then setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[output[4]]));end;
			renderText(posX+self.visualHud.maxWidth-txtWidth, posY-txtHeight, size, tostring(output[2]));
			posY = posY-txtHeight;
			isOutput = true;
		end;
		if isOutput and AnimalsManagerVisualHud.loadOverlays then
			AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["lineAnimalVisual"], posX+widthDistance,posY-(heightDistance/2),self.visualHud.maxWidth/2, heightDistance/4}, "setOverlay BackgroundLine AnimalsVisualHud");
			AnimalsManager:get_hl("setBackgroundColor", {AnimalsManager.overlays["lineAnimalVisual"], {1,1,1,0.7}}, "setBackgroundLineColor update lineAnimalVisual");
			AnimalsManager.overlays["lineAnimalVisual"]:render();
		end;
		for key, input in pairs(self.visualHud.input) do			
			setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[1]));
			local txtHeight = getTextHeight(size, tostring(input[1]))+heightDistance;			
			if input[3] > 0 then setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[input[3]]));end;
			if self.visualHudFillTypesTicker ~= nil and self.visualHudFillTypesTicker[key] ~= nil then
				self.visualHudFillTypesTicker[key].isTimer = self.visualHudFillTypesTicker[key].isTimer+1;
				if self.visualHudFillTypesTicker[key].isTimer < 400 then
					renderText(posX+widthDistance, posY-txtHeight, size, tostring(input[1]))
				else
					local isTimer = 100*self.visualHudFillTypesTicker[key].isFillType;
					local maxTimer = 100*(#self.visualHudFillTypesTicker[key].fillTypes);					
					local fillTypeName = FillTypeManager.getFillTypeNameByIndex(g_fillTypeManager, self.visualHudFillTypesTicker[key].fillTypes[self.visualHudFillTypesTicker[key].isFillType]);
					local getFillTypeName = g_fillTypeManager.nameToFillType[fillTypeName].title;
					setTextBold(false);
					setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[4]));
					renderText(posX+widthDistance, posY-txtHeight, size, tostring(getFillTypeName));
					setTextBold(true);
					if self.visualHudFillTypesTicker[key].isTimer > 400+isTimer then self.visualHudFillTypesTicker[key].isFillType=self.visualHudFillTypesTicker[key].isFillType+1;end;
					if self.visualHudFillTypesTicker[key].isFillType > #self.visualHudFillTypesTicker[key].fillTypes then self.visualHudFillTypesTicker[key].isFillType=1;end;
					if self.visualHudFillTypesTicker[key].isTimer > 400+maxTimer then self.visualHudFillTypesTicker[key].isTimer=0;self.visualHudFillTypesTicker[key].isFillType=1;end;
				end;
			else
				AnimalsManagerVisualHud.globalTimer = 0;
				renderText(posX+widthDistance, posY-txtHeight, size, tostring(input[1]));
			end;			
			setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[1]));
			local txtWidth = getTextWidth(size, tostring(input[2]))+widthDistance;			
			if input[4] > 0 then setTextColor(unpack(AnimalsManagerVisualHud.color.prozent[input[4]]));end;
			renderText(posX+self.visualHud.maxWidth-txtWidth, posY-txtHeight, size, tostring(input[2]));
			posY = posY-txtHeight;
		end;
		if AnimalsManagerVisualHud.loadOverlays then
			AnimalsManager:get_hl("setBackgroundColor", {AnimalsManager.overlays["lineAnimalVisual"], {1,1,1,0.7}}, "setBackgroundLineColor update lineAnimalVisual");
			AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["lineAnimalVisual"], AnimalsManager.overlays["groundAnimalVisual"].x+AnimalsManager.overlays["groundAnimalVisual"].width-(heightDistance/4),AnimalsManager.overlays["groundAnimalVisual"].y,heightDistance/4, self.visualHud.maxHeight+heightDistance}, "setOverlay BackgroundLine AnimalsVisualHud");
			AnimalsManager.overlays["lineAnimalVisual"]:render();
			AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["lineAnimalVisual"], AnimalsManager.overlays["groundAnimalVisual"].x,AnimalsManager.overlays["groundAnimalVisual"].y+AnimalsManager.overlays["groundAnimalVisual"].height,self.visualHud.maxWidth, heightDistance/4}, "setOverlay BackgroundLine AnimalsVisualHud");
			AnimalsManager.overlays["lineAnimalVisual"]:render();		
			AnimalsManager:get_hl("setOverlay", {AnimalsManager.overlays["lineAnimalVisual"], posX,posY-(heightDistance*2),self.visualHud.maxWidth, heightDistance}, "setOverlay BackgroundLine AnimalsVisualHud");
			AnimalsManager:get_hl("setBackgroundColor", {AnimalsManager.overlays["lineAnimalVisual"], {255/255,65/255,0/255,0.7}}, "setBackgroundLineColor update lineAnimalVisual");
			AnimalsManager.overlays["lineAnimalVisual"]:render();		
		end;
		--respect settings for other mods
		setTextAlignment(0);
		setTextColor(1, 1, 1, 1);
		setTextBold(false);
		--respect settings for other mods
	end;
end;

local onPrint=true;
function AnimalsManagerVisualHud:createHud(self)
	local animalModule = self:getModuleByName("animals");
	if animalModule ~= nil then		
		local animalName = tostring(animalModule:getAnimalType():lower());		
		self.visualHud = {output={}, input={}, isVisible=false, maxWidth=0, maxHeight=0};
		local animalNumber = "LARGE";
		if string.find(self.i3dFilename:lower(), "small") then animalNumber = "SMALL";end;
		table.insert(self.visualHud.output, {Utils.getNoNil(g_i18n:getText("animalPen_".. tostring((animalName))), "Name Unknown"), animalNumber, 0, 0, {}, {} });
		table.insert(self.visualHud.output, {g_i18n:getText("animal_stock"), Utils.getNoNil(animalModule:getNumOfAnimals(), 0), 0, 0, {}, {} });
		
		if animalName ~= "horse" and animalName ~= "dog" then
			if animalModule.reproductionRatesPerDay ~= nil then					
				local reproductionTimePerDay = 0;
				for fillType, rates in pairs(animalModule.reproductionRatesPerDay) do					
					if rates > 0 then
						reproductionTimePerDay = animalModule:getReproductionTimePerDay(fillType);
						break;							
					end;
				end;
				reproductionTimePerDay = g_i18n:formatMinutes(reproductionTimePerDay);
				table.insert(self.visualHud.output, {g_i18n:getText("statistic_reproductionRate"), tostring(reproductionTimePerDay), 0, 0, {}, {} });							
			end;
			--if animalModule.newAnimalPercentages ~= nil then					
			--	local newAnimalPercentages = 0;
			--	for fillType, rates in pairs(animalModule.newAnimalPercentages) do					
			--		if rates > 0 then
			--			newAnimalPercentages = rates;
			--			break;							
			--		end;
			--	end;
			--	local reproductionDuration = 1.0 / newAnimalPercentages
			--	local reproMins = reproductionDuration * 24 * 60
			--	newAnimalPercentages = g_i18n:formatMinutes(reproMins);
			--	table.insert(self.visualHud.output, {g_i18n:getText("statistic_timeTillNextAnimal"), tostring(newAnimalPercentages), 0, 0, {}, {} });							
			--end;
			local prozentColor, isOkay = AnimalsManager:get_hl("getProzentColor", {Utils.getNoNil(self.globalProductionFactor, 0)*100, true}, "getProzentColor Productivity ".. tostring(animalName:upper()));
			if not isOkay then prozentColor = 0;end;
			table.insert(self.visualHud.output, {g_i18n:getText("statistic_productivity"), g_i18n:formatNumber(Utils.getNoNil(self.globalProductionFactor, 0)*100), 0, prozentColor, {}, {} });
			local foodSpillageModule = self:getModuleByName("foodSpillage");
			if foodSpillageModule ~= nil and foodSpillageModule.hasCleanliness then
				prozentColor, isOkay = AnimalsManager:get_hl("getProzentColor", {Utils.getNoNil(foodSpillageModule:getSpillageFactor(), 0)*100, true}, "getProzentColor Dirt ".. tostring(animalName:upper()));
				if not isOkay then prozentColor = 0;end;
				table.insert(self.visualHud.output, {g_i18n:getText("statistic_cleanliness"), g_i18n:formatNumber(Utils.getNoNil(foodSpillageModule:getSpillageFactor(), 0)*100), 0, prozentColor, {}, {} });
			else
				
			end;				
		end;
		local milkModule = self:getModuleByName("milk");
		if milkModule ~= nil then table.insert(self.visualHud.output, {g_i18n:getText("statistic_milkStorage"), AnimalsManagerVisualHud:getFillTypeLevels(milkModule:getFilltypeInfos()), 0, 0, {}, {} });end;
		local liquidManureModule = self:getModuleByName("liquidManure");
		if liquidManureModule ~= nil then table.insert(self.visualHud.output, {g_i18n:getText("statistic_liquidManureStorage"), AnimalsManagerVisualHud:getFillTypeLevels(liquidManureModule:getFilltypeInfos()), 0, 0, {}, {} });end;
		local manureModule = self:getModuleByName("manure");
		if manureModule ~= nil then table.insert(self.visualHud.output, {g_i18n:getText("statistic_manureStorage"), AnimalsManagerVisualHud:getFillTypeLevels(manureModule:getFilltypeInfos()), 0, 0, {}, {} });end;
		local palletsModule = self:getModuleByName("pallets");
		if palletsModule ~= nil then table.insert(self.visualHud.output, {g_i18n:getText("category_pallets"), AnimalsManagerVisualHud:getFillTypePal(palletsModule), 0, 0, {}, {} });end;
		
		local waterModule = self:getModuleByName("water");
		if waterModule ~= nil then table.insert(self.visualHud.input, {g_i18n:getText("statistic_water"), AnimalsManagerVisualHud:getFillTypeLevels(waterModule:getFilltypeInfos()), 0, 0, {}, {} });end;
		local strawModule = self:getModuleByName("straw");
		if strawModule ~= nil then table.insert(self.visualHud.input, {g_i18n:getText("statistic_strawStorage"), AnimalsManagerVisualHud:getFillTypeLevels(strawModule:getFilltypeInfos()), 0, 0, {}, {} });end;
		local foodModule = self:getModuleByName("food");
		if foodModule ~= nil then					
			local foodModuleTotal = foodModule:getFilltypeInfos();					
			if foodModuleTotal ~= nil and type(foodModuleTotal) == "table" and #foodModuleTotal > 0 then
				local isCapacity = false;
				for key, foodGroupTable in pairs(foodModuleTotal) do							
					if foodGroupTable ~= nil then
						if not isCapacity then 
							table.insert(self.visualHud.output, 2, {g_i18n:getText("shop_capacity"), Utils.getNoNil(g_i18n:formatNumber(foodGroupTable.capacity), 0), 0, 0, {}, {} });
							isCapacity = true;
						end;
						local fillLevelTotal = g_i18n:formatNumber(foodGroupTable.fillLevel);
						local fillTypesTotal = {};								
						if foodGroupTable.foodGroup ~= nil and foodGroupTable.foodGroup.fillTypes ~= nil then
							local foodGroupName = Utils.getNoNil(foodGroupTable.foodGroup.title, "Unknown");
							for _, fillType in pairs(foodGroupTable.foodGroup.fillTypes) do
								table.insert(fillTypesTotal, fillType);
							end;
							if #fillTypesTotal == 1 then 
								local fillTypeName = FillTypeManager.getFillTypeNameByIndex(g_fillTypeManager, fillTypesTotal[1]);
								foodGroupName = g_fillTypeManager.nameToFillType[fillTypeName].title;
							else
								if self.visualHudFillTypesTicker == nil then 
									self.visualHudFillTypesTicker = {};									
								end;
								if self.visualHudFillTypesTicker[#self.visualHud.input+1] == nil then self.visualHudFillTypesTicker[#self.visualHud.input+1] = {isTimer=0, isFillType=1};end;
							end;								
							table.insert(self.visualHud.input, {tostring(foodGroupName), fillLevelTotal, 0, 0, fillTypesTotal, {} });
							if self.visualHudFillTypesTicker ~= nil and self.visualHudFillTypesTicker[#self.visualHud.input] ~= nil then self.visualHudFillTypesTicker[#self.visualHud.input].fillTypes = fillTypesTotal;end;
						end;
					end;
				end;						
			end;					
		end;
		self.visualHud.maxWidth, self.visualHud.maxHeight = AnimalsManagerVisualHud:setAnimalsTxtWidthHeightTotal(self);		
	end;
end;

function updateModule(self, moduleName, isUpdateDefault, whatOutInput, pos, isColorUpdate)
	local isModule = self:getModuleByName(moduleName);
	if isModule ~= nil then
		if isUpdateDefault then
			self.visualHud[whatOutInput][pos][2] = AnimalsManagerVisualHud:getFillTypeLevels(isModule:getFilltypeInfos());
			local w1 = getTextWidth(AnimalsManagerVisualHud.size, tostring(self.visualHud[whatOutInput][pos][2]))+AnimalsManagerVisualHud.widthDistance;			
			if self.visualHud.maxWidth < w1 then self.visualHud.maxWidth = w1;end;
			return true;
		end;
		return isModule;
	end;
	return nil;
end;

function AnimalsManagerVisualHud:setAnimalsTxtWidthHeightTotal(self)
	local maxWidth = 0;
	local maxHeight = 0;
	local widthDistance = AnimalsManagerVisualHud.widthDistance;
	local heightDistance = AnimalsManagerVisualHud.heightDistance;
	local size = AnimalsManagerVisualHud.size;
	for whatTable, animalTable in pairs(self.visualHud.output) do
		local w1 = getTextWidth(size, tostring(animalTable[1]))+widthDistance;
		local w2 = getTextWidth(size, tostring(animalTable[2]))+widthDistance;
		local h1 = getTextHeight(size, tostring(animalTable[1]))+heightDistance;
		local h2 = getTextHeight(size, tostring(animalTable[2]))+heightDistance;
		if maxWidth < w1+w2+AnimalsManagerVisualHud.widthSeparatorDistance then maxWidth = w1+w2+AnimalsManagerVisualHud.widthSeparatorDistance;end;
		maxHeight = maxHeight+math.max(h1, h2);
	end;
	for whatTable, animalTable in pairs(self.visualHud.input) do
		local w1 = getTextWidth(size, tostring(animalTable[1]))+widthDistance;
		local w2 = getTextWidth(size, tostring(animalTable[2]))+widthDistance;
		local h1 = getTextHeight(size, tostring(animalTable[1]))+heightDistance;
		local h2 = getTextHeight(size, tostring(animalTable[2]))+heightDistance;
		if maxWidth < w1+w2+AnimalsManagerVisualHud.widthSeparatorDistance then maxWidth = w1+w2+AnimalsManagerVisualHud.widthSeparatorDistance;end;
		maxHeight = maxHeight+math.max(h1, h2);
	end;
	return maxWidth, maxHeight;
end;

function AnimalsManagerVisualHud:getFillTypePal(palletsModule)
	local maxDistance = 6;
	local palTotal = 0;	
	local x0,y0,z0 = getWorldTranslation(palletsModule.palletSpawnerNode);
	local result = getMapItems()
	if result ~= nil and palletsModule.palletFillTypeIndex ~= nil and result[palletsModule.palletFillTypeIndex] ~= nil then	
		for _, pal in pairs (result[palletsModule.palletFillTypeIndex]) do			
			if pal.x ~= nil and pal.y ~= nil and pal.z ~= nil then				
				local distance = MathUtil.vector3Length(pal.x-x0, pal.y-y0, pal.z-z0);
				if distance < maxDistance then palTotal = palTotal+1;end;
			end;
		end;
	end;	
	return palTotal;
end;

function getMapItems()
	local result = {};
	for key, value in pairs (g_currentMission.ownedItems) do
		if key ~= nil and value ~= nil and value.items ~= nil and type(value.items) == "table" then			
			for _, item in pairs(value.items) do				
				if item ~= nil and type(item) == "table" and item.typeName ~= nil and (string.find(item.typeName:lower(), "pallet")) then
					if item.spec_fillUnit ~= nil and item.spec_fillUnit.fillUnits ~= nil and item.spec_fillUnit.fillUnits[1] ~= nil and item.spec_fillUnit.fillUnits[1].fillType ~= nil then
						local fillType = item.spec_fillUnit.fillUnits[1].fillType;						
						if item.spec_fillUnit.fillUnits[1].fillLevel == item.spec_fillUnit.fillUnits[1].capacity then
							local x0,y0,z0 = getWorldTranslation(item.rootNode);
							if result[fillType] == nil then result[fillType] = {};end;
							result[fillType][#result[fillType]+1] = {amount=1,fillLevel=item.spec_fillUnit.fillUnits[1].fillLevel,x=x0,y=y0,z=z0};							
						end;
					end;							
				end;
			end;
		end;
	end;
	return result;
end;

function AnimalsManagerVisualHud:getFillTypeLevels(fillTypeModule)
	local fillLevelsTotal = 0;
	local fillTypeIndex = 0;
	if fillTypeModule ~= nil and type(fillTypeModule) == "table" then
		for _, fillType in pairs(fillTypeModule) do
			fillLevelsTotal = fillLevelsTotal+fillType.fillLevel;
			fillTypeIndex = fillType.fillType;
		end;
	end;
	return g_i18n:formatNumber(fillLevelsTotal);
end;